#include <avr/io.h>
#include "DRAMIO.h"


.global	read_byte
read_byte:

;bergabe in r22-r25 (r25 = MSB)
;Verwendete Register:	r19 = temp Register, r21 = DDR Umschaltung

	cli
	ldi r19, (1<<CASL)|(1<<CASH)|(1<<RAS)|(1<<WE)
#if (DRAMWORD==256)
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A8
#elif (DRAMWORD<=1024)
	bst r24, 2									;Adresse(2.2) laden
	bld r19, A8
	bst r24, 3									;Adresse(2.3) laden
	bld r19, A9
#elif (DRAMWORD<=4096)
	bst r24, 3									;Adresse(2.3) laden
	bld r19, A8
	bst r24, 4									;Adresse(2.4) laden
	bld r19, A9
	bst r24, 5									;Adresse(2.5) laden
	bld r19, A10
#endif
	out (_SFR_IO_ADDR(DRAMADR)), r23 			;Adresse(1) ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19			;Adresse(2) ausgeben
	cbr r19, (1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL), r19 			;RAS aktivieren

#if (DRAMWORD==256)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
#elif (DRAMWORD<=1024)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A9
#elif (DRAMWORD<=4096)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A9
	bst r24, 2									;Adresse(2.2) laden
	bld r19, A10
#endif
	out (_SFR_IO_ADDR(DRAMADR)), r22 			;Adresse(0) ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19			;Adresse(2) ausgeben
#if ((DRAMWORD==256)&&(DRAMBITS==16))
    sbrs r24, 2
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 2
    cbr r19, (1<<CASH)							;CASH laden
#elif ((DRAMWORD<=1024)&&(DRAMBITS==16))
    sbrs r24, 4
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 4
    cbr r19, (1<<CASH)							;CASH laden
#elif ((DRAMWORD<=4096)&&(DRAMBITS==16))
    sbrs r24, 6
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 6
    cbr r19, (1<<CASH)							;CASH laden
#elif (DRAMBITS==8)
    cbr r19, (1<<CASL)							;CASL laden
#endif
	clr r21
	out _SFR_IO_ADDR(DRAMPORT)-1, r21			;Port auf Eingang schalten
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;CAS aktivieren
	ser r21
	ldi r19, (1<<CASL)|(1<<CASH)|(1<<RAS)|(1<<WE)
	in r24, _SFR_IO_ADDR(DRAMPORT)-2			;Wert lesen
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;Read beenden
	out _SFR_IO_ADDR(DRAMPORT)-1, r21			;Port auf Ausgang schalten

#if (ReadRefresh==1)
	lds r19,Refresh
	tst r19
	breq NoRefresh1
	ldi r19,(1<<WE)|(1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL),r19
NoRefresh1:
#endif

	sei
	ret

.global	write_byte
write_byte:

;bergabe Adresse in r22-r25 (r25 = MSB)
;bergabe Datenwert in r20
;Verwendete Register:	r19 = temp Register

	cli
	ldi r19, (1<<CASL)|(1<<CASH)|(1<<RAS)|(1<<WE)
#if (DRAMWORD==256)
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A8
#elif (DRAMWORD<=1024)
	bst r24, 2									;Adresse(2.2) laden
	bld r19, A8
	bst r24, 3									;Adresse(2.3) laden
	bld r19, A9
#elif (DRAMWORD<=4096)
	bst r24, 3									;Adresse(2.3) laden
	bld r19, A8
	bst r24, 4									;Adresse(2.4) laden
	bld r19, A9
	bst r24, 5									;Adresse(2.5) laden
	bld r19, A10
#endif
	out (_SFR_IO_ADDR(DRAMADR)), r23 			;Adresse(1) ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19			;Adresse(2) ausgeben
	cbr r19, (1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL), r19 			;RAS aktivieren

#if (DRAMWORD==256)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
#elif (DRAMWORD<=1024)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A9
#elif (DRAMWORD<=4096)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A9
	bst r24, 2									;Adresse(2.2) laden
	bld r19, A10
#endif
	out (_SFR_IO_ADDR(DRAMADR)), r22 			;Adresse(0) ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19			;Adresse(2) ausgeben
#if ((DRAMWORD==256)&&(DRAMBITS==16))
    sbrs r24, 2
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 2
    cbr r19, (1<<CASH)							;CASH laden
#elif ((DRAMWORD<=1024)&&(DRAMBITS==16))
    sbrs r24, 4
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 4
    cbr r19, (1<<CASH)							;CASH laden
#elif ((DRAMWORD<=4096)&&(DRAMBITS==16))
    sbrs r24, 6
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 6
    cbr r19, (1<<CASH)							;CASH laden
#elif (DRAMBITS==8)
    cbr r19, (1<<CASL)							;CASL laden
#endif
	cbr r19, (1<<WE)							;Early Write
	out _SFR_IO_ADDR(DRAMPORT), r20				;Daten ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;CAS aktivieren
	ldi r19, (1<<CASL)|(1<<CASH)|(1<<RAS)|(1<<WE)
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;Write beenden

#if (ReadRefresh==1)
	lds r19,Refresh
	tst r19
	breq NoRefresh2
	ldi r19,(1<<WE)|(1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL),r19
NoRefresh2:
#endif

	sei
	ret

.global	read_string
read_string:

;bergabe Adresse in r22-r25 (r25 = MSB)
;bergabe Pointer in r20-r21 (r21 = MSB)
;bergabe Anzahl  in r18
;Verwendete Register:	r19 = temp Register, r21 = DDR Umschaltung, Readbyte

#define Anzahl r18

	cli
	push XL
	push XH
	movw XL, r20								;Pointer in X Register laden
	clr r21
	out _SFR_IO_ADDR(DRAMPORT)-1, r21			;Port auf Eingang schalten
read_ras:
	ldi r19, (1<<CASL)|(1<<CASH)|(1<<RAS)|(1<<WE)
#if (DRAMWORD==256)
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A8
#elif (DRAMWORD<=1024)
	bst r24, 2									;Adresse(2.2) laden
	bld r19, A8
	bst r24, 3									;Adresse(2.3) laden
	bld r19, A9
#elif (DRAMWORD<=4096)
	bst r24, 3									;Adresse(2.3) laden
	bld r19, A8
	bst r24, 4									;Adresse(2.4) laden
	bld r19, A9
	bst r24, 5									;Adresse(2.5) laden
	bld r19, A10
#endif
	out (_SFR_IO_ADDR(DRAMADR)), r23 			;Adresse(1) ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19			;Adresse(2) ausgeben
	cbr r19, (1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL), r19 			;RAS aktivieren
#if (DRAMWORD==256)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
#elif (DRAMWORD<=1024)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A9
#elif (DRAMWORD<=4096)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A9
	bst r24, 2									;Adresse(2.2) laden
	bld r19, A10
#endif
read_cas:
	out (_SFR_IO_ADDR(DRAMADR)), r22 			;Adresse(0) ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19			;Adresse(2) ausgeben
#if ((DRAMWORD==256)&&(DRAMBITS==16))
    sbrs r24, 2
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 2
    cbr r19, (1<<CASH)							;CASH laden
#elif ((DRAMWORD<=1024)&&(DRAMBITS==16))
    sbrs r24, 4
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 4
    cbr r19, (1<<CASH)							;CASH laden
#elif ((DRAMWORD<=4096)&&(DRAMBITS==16))
    sbrs r24, 6
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 6
    cbr r19, (1<<CASH)							;CASH laden
#elif (DRAMBITS==8)
    cbr r19, (1<<CASL)							;CASL laden
#endif
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;CAS aktivieren
#if (DRAMBITS==8)
	sbr r19, (1<<CASL)|(1<<WE)
#elif (DRAMBITS==16)
	sbr r19, (1<<CASL)|(1<<CASH)|(1<<WE)
#endif
	nop											;Notwendig bei langsamen Speichern/groen Speicherbnken
	in r21, _SFR_IO_ADDR(DRAMPORT)-2			;Wert lesen
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;Read beenden
	st X+, r21
	dec Anzahl
	breq exread									;Wenn alle Werte gelesen -> Exit

	subi r22, lo8(-1)							;Adresszhler erhhen
	brcs read_cas								;Wenn 256Byte Grenze nicht berschritten -> Page Mode Read
	sbci r23, hi8(-1)							;Ansonsten alle restlichen Adressen die Carrys addieren
	sbci r24, hi8(-1)
	sbci r25, hi8(-1)
	rjmp read_ras								;komplett neuen Read starten

exread:
	sbr r19, (1<<CASL)|(1<<CASH)|(1<<WE)|(1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;Read beenden (RAS setzen)
	ser r21
	out _SFR_IO_ADDR(DRAMPORT)-1, r21			;Port auf Ausgang schalten

#if (ReadRefresh==1)
	lds r19,Refresh
	tst r19
	breq NoRefresh3
	ldi r19,(1<<WE)|(1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL),r19
NoRefresh3:
#endif

	pop XH
	pop XL
	sei
	ret

.global	write_string
write_string:

;bergabe Adresse in r22-r25 (r25 = MSB)
;bergabe Pointer in r20-r21 (r21 = MSB)
;bergabe Anzahl  in r18
;Verwendete Register:	r19 = temp Register, r21 = Readbyte

	cli
	push XL
	push XH
	movw XL, r20								;Pointer in X Register laden
write_ras:
	ldi r19, (1<<CASL)|(1<<CASH)|(1<<RAS)|(1<<WE)
#if (DRAMWORD==256)
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A8
#elif (DRAMWORD<=1024)
	bst r24, 2									;Adresse(2.2) laden
	bld r19, A8
	bst r24, 3									;Adresse(2.3) laden
	bld r19, A9
#elif (DRAMWORD<=4096)
	bst r24, 3									;Adresse(2.3) laden
	bld r19, A8
	bst r24, 4									;Adresse(2.4) laden
	bld r19, A9
	bst r24, 5									;Adresse(2.5) laden
	bld r19, A10
#endif
	out (_SFR_IO_ADDR(DRAMADR)), r23 			;Adresse(1) ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19			;Adresse(2) ausgeben
	cbr r19, (1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL), r19 			;RAS aktivieren

#if (DRAMWORD==256)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
#elif (DRAMWORD<=1024)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A9
#elif (DRAMWORD<=4096)
	bst r24, 0									;Adresse(2.0) laden
	bld r19, A8
	bst r24, 1									;Adresse(2.1) laden
	bld r19, A9
	bst r24, 2									;Adresse(2.2) laden
	bld r19, A10
#endif
write_cas:
	out (_SFR_IO_ADDR(DRAMADR)), r22 			;Adresse(0) ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19			;Adresse(2) ausgeben
#if ((DRAMWORD==256)&&(DRAMBITS==16))
    sbrs r24, 2
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 2
    cbr r19, (1<<CASH)							;CASH laden
#elif ((DRAMWORD<=1024)&&(DRAMBITS==16))
    sbrs r24, 4
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 4
    cbr r19, (1<<CASH)							;CASH laden
#elif ((DRAMWORD<=4096)&&(DRAMBITS==16))
    sbrs r24, 6
    cbr r19, (1<<CASL)							;CASL laden
    sbrc r24, 6
    cbr r19, (1<<CASH)							;CASH laden
#elif (DRAMBITS==8)
    cbr r19, (1<<CASL)							;CASL laden
#endif
	cbr r19, (1<<WE)							;Early Write
	ld r21, X+									;Daten vom Pointer lesen
	out _SFR_IO_ADDR(DRAMPORT), r21				;Daten ausgeben
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;CAS aktivieren
#if (DRAMBITS==8)
	sbr r19, (1<<CASL)|(1<<WE)
#elif (DRAMBITS==16)
	sbr r19, (1<<CASL)|(1<<CASH)|(1<<WE)
#endif
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;Write beenden
	dec Anzahl
	breq exwrite								;Wenn alle Werte geschrieben -> Exit

	subi r22, lo8(-1)							;Adresszhler erhhen
	brcs write_cas								;Wenn 256Byte Grenze nicht berschritten -> Page Mode Write
	sbci r23, hi8(-1)							;Ansonsten alle restlichen Adressen die Carrys addieren
	sbci r24, hi8(-1)
	sbci r25, hi8(-1)
	rjmp write_ras								;komplett neuen Write starten

exwrite:
	ldi r19, (1<<CASL)|(1<<CASH)|(1<<WE)|(1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL), r19   		;Write beenden (RAS setzen)

#if (ReadRefresh==1)
	lds r19,Refresh
	tst r19
	breq NoRefresh4
	ldi r19,(1<<WE)|(1<<RAS)
	out _SFR_IO_ADDR(DRAMCONTROL),r19
NoRefresh4:
#endif

	pop XH
	pop XL
	sei
	ret

.global SIG_OVERFLOW0
SIG_OVERFLOW0:

	push r16
	in r16,_SFR_IO_ADDR(SREG) 
	push r16

	push r24
	push r25

#if (ReadRefresh==1)
	ldi r24,1
	sts Refresh,r24
#endif

	sei

	ldi r24,(1<<WE)
	ldi r25,(1<<WE)|(1<<RAS)

	clr r16

lop:out _SFR_IO_ADDR(DRAMCONTROL), r25 
	out _SFR_IO_ADDR(DRAMCONTROL), r24 
	out _SFR_IO_ADDR(DRAMCONTROL), r25 
	out _SFR_IO_ADDR(DRAMCONTROL), r24 
	out _SFR_IO_ADDR(DRAMCONTROL), r25 
	out _SFR_IO_ADDR(DRAMCONTROL), r24 
	out _SFR_IO_ADDR(DRAMCONTROL), r25 
	out _SFR_IO_ADDR(DRAMCONTROL), r24 
	dec r16
	brne lop

	ldi r25, (1<<WE)|(1<<RAS)|(1<<CASH)|(1<<CASL)
	out _SFR_IO_ADDR(DRAMCONTROL) ,r25

#if (ReadRefresh==1)
	sts Refresh,r16
#endif

	pop r25
	pop r24
	pop r16
	out _SFR_IO_ADDR(SREG) ,r16
	pop r16

	reti


