#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/pgmspace.h>
#include "dram.h"
#include "dramIO.h"
#include "uart.h"

#define XTAL_CPU        18432000 
#define UART_BAUD_RATE    230400 

unsigned long readpointer=0;
unsigned char Divider=39;		//11,025kHz


//Beschreibung: Siehe DRAM.c


int main(void)
{ 
	unsigned int c;
    uart_init(UART_BAUD_SELECT(UART_BAUD_RATE, XTAL_CPU)); 

	sei(); 

    uart_puts_P("Testing Memory........."); 

    if (mem_init()) 
		{uart_puts_P("failed !\n");     
		for (;;);  }
    else
		uart_puts_P("successfull !\n");           

	TCCR1A=(1<<COM1B1)|(1<<WGM10);
	DDRE=255;
	TCCR1B=(1<<WGM12)|1;

    for(;;)
 {   c = uart_getc();
        if ( c & UART_NO_DATA )
            { }
       
        else if (c==10)		//Befehl 10		DRAM Inhalt ber UART ausgaben
			readMem();
        else if (c==11)		//Befehl 11		DRAM Inhalt ber UART laden. Danach mssen soviele Bytes gesendet werden wie der DRAM gro ist
			writeMem();
        else if (c==1)		//Befehl 1		Widergabe starten: Der DRAM wird mittels PWM an IC1B abgespielt
			{
			TIMSK|=(1<<TOV1);
			readpointer=0;
			}
        else if (c==2)		//Befehl 2		Widergabe stoppen
			TIMSK&=~(1<<TOV1);
        else if (c==3)		//Befehl 3		Samplerate einstellen: Samplerate=281,25Hz*Wert
			{
	  	while ((c = uart_getc()) & UART_NO_DATA);
			Divider=(char)c;
			}      
	}
}


INTERRUPT(SIG_OVERFLOW1)                //281Hz Takt
{   static unsigned char divider;
	divider+=Divider;
	if (divider<Divider)
	{
		OCR1B=read_byte(readpointer);
		readpointer++;
		if (readpointer==(long)DRAMSIZE*1024L)
			readpointer=0;
	}
}






